#include <stdio.h>
#include <omp.h>

__attribute__((constructor))
static void init ()
{
  printf ("lib3 loaded\n");
}

__attribute__((destructor))
static void fini ()
{
  printf ("lib3 unloaded\n");
}

#pragma omp declare target
int calc_in_lib3 (int x)
{
  return 10 * x;
}
#pragma omp end declare target

void f3 (int *p)
{
  int x = *p, d = 1;
  printf ("%s ()\t", __FUNCTION__);

  #pragma omp target device (0)
    {
      x += 3;
      d = omp_is_initial_device ();
    }

  printf (d ? "HOST\n" : "TARGET\n");
  *p = x;
}
