#include <stdio.h>
#include <omp.h>

#pragma omp declare target
int calc_in_lib3 (int x);
#pragma omp end declare target

__attribute__((constructor))
static void init ()
{
  printf ("lib4 loaded\n");
}

__attribute__((destructor))
static void fini ()
{
  printf ("lib4 unloaded\n");
}

void f4 (int *p)
{
  int x = *p, d = 1;
  printf ("%s ()\t", __FUNCTION__);

  #pragma omp target device (0)
    {
      x = calc_in_lib3 (x);
      d = omp_is_initial_device ();
    }

  printf (d ? "HOST\n" : "TARGET\n");
  *p = x;
}
