#include <stdlib.h>
#include <assert.h>
#include <dlfcn.h>
#include <stdio.h>

extern void f1 (int *);

void *open_lib (const char *lib_name)
{
  void *handle = dlopen (lib_name, RTLD_LAZY);
  if (!handle)
  {
    printf ("%s\n", dlerror ());
    exit (1);
  }
  return handle;
}

void call_func (void *handle, const char *func_name, int *x)
{
  void (*func)(int *) = dlsym (handle, func_name);
  char *error;
  if ((error = dlerror ()) != NULL)
  {
    printf ("%s\n", error);
    exit (1);
  }

  func (x);
}

int main ()
{
  int x = 0;
  void *h2, *h3, *h4;

  f1 (&x);
  assert (x == 1);

  h2 = open_lib ("lib2.so");
  call_func (h2, "f2", &x);
  assert (x == 3);
  dlclose (h2);

  h3 = open_lib ("lib3.so");
  h2 = open_lib ("lib2.so");
  call_func (h3, "f3", &x);
  assert (x == 6);
  call_func (h2, "f2", &x);
  assert (x == 8);
  dlclose (h2);

  h4 = open_lib ("lib4.so");
  call_func (h4, "f4", &x);
  assert (x == 80);
  dlclose (h4);
  dlclose (h3);

  return 0;
}
